//SpiraleVariabel_401d.js
// 28.12.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zeichnet eine Spirale

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// testen, ob ein Objekt ausgewhlt ist
if (app.selection.length == 0) {
	alert ("Bitte einen Rahmen auswhlen.", "Achtung");
	exit();
}

// das aktuelle Dokument
var curDoc = app.documents[0];

// Masseinheiten, Linealursprung und Nullpunkt speichern
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
rO = curDoc.viewPreferences.rulerOrigin;
zP = curDoc.zeroPoint;
tR = curDoc.layoutWindows[0].transformReferencePoint;

// Einstellungen ndern
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
curDoc.zeroPoint = [0,0];
curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.topLeftAnchor;

// die Abmessungen der Auswahl speichern
try {
	var gB = app.selection[0].geometricBounds;
}
catch (e) {
	alert ("Bitte einen rechteckigen Rahmen auswhlen.", "Stop");
	reStoreSettings();
	exit();
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
ck01 = ck02 = 0;
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	strW = prefVal[0]*1;
	strT = prefVal[1]*1;
	dtV1 = prefVal[2]*1;
	dtV2 = prefVal[3]*1;
	numV = prefVal[4]*1;
	delV = prefVal[5]*1;
	rb01 = prefVal[6]*1;
	if (rb01 == 0) {
		ck01 = 1;
	}
	else {
		ck02 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	strW = 1;
	strT = 100;
	dtV1 = 20;
	dtV2 = 5;
	numV = 15;
	delV = 0;
	ck01 = 1;
	ck02 = 0;
}

// die Funktion aufrufen, welche den Dialog zeigt und das Ergebnis zurckgibt
var anArray  = displayDialog();
var strW     = anArray[0];
var strT     = anArray[1];
var distVal1 = anArray[2];
var distVal2 = anArray[3];
var numVal   = anArray[4];
var delVal   = anArray[5];
var dirDec   = anArray[6];

// die Positionen y1, x1, x2
var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
	
if (distVal1 == distVal2) {
	distVal = distVal1;
	// die halbe Distanz
	var halfDst = distVal/2;
	
	// die Breite des Rahmens mit dem Abstandswert vergleichen
	if ((x2-x1) <= distVal) {
		alert ("Der Musterrahmen ist nicht breit genug.\nMindest-Breite = " + (distVal+0.1) + " mm", "Stop");
		reStoreSettings();
		exit();
	}
	
	// die Anzahl Halbkreise errechnen
	var nFrames = Math.ceil((x2-x1)/(distVal));
	
	// den x2-Wert neu berechnen
	var x2 = x1+(nFrames*distVal);
	
	// die Position y2
	var y2 = y1+(x2-x1);
	
	// vergleichen mit den zu entfernenden Viertelkreisen
	if (delVal >= nFrames*2) {
		var maxVal = (nFrames*2)-1;
		alert ("Maximal " + maxVal + " Viertelkreise sind zu entfernen.\n" + delVal + " ist ein zu grosser Wert.", "Stop");
		reStoreSettings();
		exit();
	}
	
	// die Anzahl Runden ausrechnen
	var nRounds = Math.ceil(nFrames/2);
	
	// die vertikale Mitte des Objekts
	var m1 = y1 + (y2-y1);
		
	// einen Array vorbereiten
	var allFrames = new Array ();
	
	// einen kreisfrmigen Rahmen erzeugen ...
	var baseOne = app.activeWindow.activePage.ovals.add();
	baseOne.properties = {geometricBounds:[y1, x1, y2, x2], fillColor:"None", strokeColor:"None"};
		// ... und an den Array anfgen
	allFrames.push(baseOne);
	
	// den Pfad ffnen
	baseOne.paths[0].pathType = PathType.OPEN_PATH;
	
	// den ersten Pfadpunkt entfernen; Ergebnis: ein Halbkreis
	baseOne.paths[0].pathPoints[0].remove();
	
	// den Halbkreis duplizieren ...
	var baseTwo = baseOne.duplicate(undefined, [0, y2-y1]);
	// ... und an den Array anfgen
	allFrames.push(baseTwo);
	
	// die Kopie spiegeln
	baseTwo.flipItem(Flip.VERTICAL);
	
	// die Kopie verkleinern
	var gB = baseTwo.geometricBounds; 
	baseTwo.geometricBounds = [gB[0], gB[1], gB[2]-halfDst, gB[3]-distVal];
	
	// in einer Schleife die Basis-Halbkreise duplizieren und verkleinern
	for (var n=0; n<nRounds-1; n++) {
	
		// den ersten Halbkreis duplizieren ...
		var newFrame = baseOne.duplicate([x1, y1]);
		// ... und an den Array anfgen
		allFrames.push(newFrame);
		
		// die Kopie verkleinern
		var gB = newFrame.geometricBounds; 
		newFrame.geometricBounds = [gB[0]+(distVal*(n+1)), gB[1]+distVal*(n+1), gB[2], gB[3]-distVal*(n+1)];
		
		try {
			// den zweiten Halbkreis duplizieren
			var newFrame = baseTwo.duplicate([x1, m1-halfDst]);
			
			// die Kopie verkleinern ...
			var gB = newFrame.geometricBounds; 
			newFrame.geometricBounds = [gB[0], gB[1]+distVal*(n+1), gB[2]-(distVal*(n+1)), gB[3]-distVal*(n+1)];
			// ... und an den Array anfgen
			allFrames.push(newFrame);
		}
		catch (e) {
			newFrame.remove();
		}
	}
}
else {
	// prfen, ob der ausgewhlte Rahmen breit genug ist
	if (x2-x1<distVal1+distVal2+numVal) {
		alert ("Einen breiteren Rahmen auswhlen.", "Stop");
		reStoreSettings();
		exit();
	}
	
	// mit 'log' und 'exp' die wachsende Zahlenreihe zwischen Start- und Endwert vorbereiten
	var d = ((Math.log(distVal1/distVal2))/numVal)*-1;
	var curDist = distVal1;
	var distSum = 0;
	var distArr = new Array ();
	// mit einer Schleife die einzelnen Werte bestimmen
	for (var n=1; n<numVal-1; n++) {
		curDist = distVal2*(Math.exp(-d*n));
		curDist = (Math.round(curDist*1000))/1000;
		// den aktuellen Wert zur Zwischensumme addieren ...
		distSum += curDist;
		// ... und an den Array anfgen
		distArr.push(curDist);
	}
	
	// den Distanz-Unterschied bestimmen
	var distDif = x2-x1-distVal1-distVal2;
	// den Faktoren ausrechnen
	var distFact = distSum/distDif;

	// den Array umkehren
	distArr.reverse();
	
	// einen neuen Array vorbereiten
	var defArr = new Array ();

	// eine Schleife durch die Werte, um sie an die Restdistanz anzupassen
	for (var n=0; n<distArr.length; n++) {
		tmpDist = Math.round((distArr[n]/distFact)*1000)/1000;
		defArr.push(tmpDist);
	}
	// den ersten und ...
	defArr.unshift(distVal1);
	// ... den letzten Abstand anfgen
	defArr.push(distVal2);

	// nochmals einen Array vorbereiten
	var allFrames = new Array ();
	
	// einen kreisfrmigen Rahmen erzeugen ...
	var y2 = y1+(x2-x1);
	var baseOne = app.activeWindow.activePage.ovals.add();
	baseOne.properties = {geometricBounds:[y1, x1, y2, x2], fillColor:"None", strokeWeight:0, strokeColor:"None"};
	// ... und an den Array anfgen
	allFrames.push(baseOne);
	
	// den Pfad ffnen
	baseOne.paths[0].pathType = PathType.OPEN_PATH;
	
	// den ersten Pfadpunkt entfernen; Ergebnis: ein Halbkreis
	baseOne.paths[0].pathPoints[0].remove();
	
	// die mittlere Position
	var gB = baseOne.geometricBounds;
	var m1 = Math.round(gB[2]*1000)/1000;
	
	// den Halbkreis duplizieren ...
	var baseTwo = baseOne.duplicate(undefined, [0, y2-y1]);
	// ... und an den Array anfgen
	allFrames.push(baseTwo);
	
	// die Kopie spiegeln
	baseTwo.flipItem(Flip.VERTICAL);
	
	// die Kopie verkleinern
	var gB = baseTwo.geometricBounds; 
	baseTwo.geometricBounds = [gB[0], gB[1], gB[2]-(distVal1/2), gB[3]-distVal1];

	// die beiden Basisrahmen neuen Variablen zuweisen
	var newFrameOne = baseOne;
	var newFrameTwo = baseTwo;

	// in einer Schleife die Halbkreise duplizieren und verkleinern
	for (var n=0; n<(numVal/2)-1; n++) {
	
		// den ersten Halbkreis duplizieren ...
		newFrameOne = newFrameOne.duplicate(undefined, [0, 0]);
		// ... und an den Array anfgen
		allFrames.push(newFrameOne);
		
		// die Kopie verkleinern
		var gB = newFrameOne.geometricBounds;
		var xt1 = gB[1]+defArr[(n*2)+1];
		var xt2 = gB[3]-defArr[n*2];
		var yt1 = m1-((xt2-xt1)/2);
		newFrameOne.geometricBounds = [yt1, xt1, m1, xt2];
		
		try {
			// den zweiten Halbkreis duplizieren
			var newFrameTwo = newFrameTwo.duplicate(undefined, [0, 0]);

			// die Kopie verkleinern
			var gB = newFrameTwo.geometricBounds; 
			var xt1 = gB[1]+defArr[(n*2)+1];
			var xt2 = gB[3]-defArr[(n*2)+2];
			var yt2 = m1+((xt2-xt1)/2);
			newFrameTwo.geometricBounds = [m1, xt1, yt2, xt2];
			// ... und an den Array anfgen
			allFrames.push(newFrameTwo);
		}
		catch (e) {
			// bei einem Problem den letzten Rahmen entfernen
			newFrameTwo.remove();
			// und die Schleife verlassen
			break;
		}
	}
}

// die Endpunkte verbinden
for (var n=1; n<allFrames.length; n++) {
	if (n%2 == 0) {
		try {
			allFrames[0].paths[0].pathPoints[n*2].join(allFrames[n].paths[0].pathPoints[0], JoinOptions.COMBINE);
		}
		catch (e) {
		}
	}
	else {
		try {
			allFrames[0].paths[0].pathPoints[n*2].join(allFrames[n].paths[0].pathPoints[2], JoinOptions.COMBINE);
		}
		catch (e) {
		}
	}
}

// der Kontur ein paar Attribute zuweisen
allFrames[0].properties = {strokeColor:"Black", strokeWeight:strW, strokeTint:strT, 
		strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};

// die Richtung umkehren
allFrames[0].paths[0].reverse ();

// wenn gewnscht, Viertelkreise entfernen
if (delVal>0) {
	if (distVal1 != distVal2) {
		defVal = delVal+2;
	}
	else {
		defVal = delVal;
	}
	for (var d=0; d<defVal; d++) {
		allFrames[0].paths[0].pathPoints[0].remove();
	}
}

// "im Uhrzeigersinn" (= Vorgabe) oder "gegen den Uhrzeigersinn"
if (dirDec == 0) {
	var dirTxt = "im Uhrzeigersinn";
}
else if (dirDec == 1) {
	var dirTxt = "gegen den Uhrzeigersinn";
	// Bezugspunkt in der Mitte auswhlen
	curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.centerAnchor;
	// die Spirale spiegeln
	allFrames[0].flipItem(Flip.VERTICAL);
}

// den Eintrag ins Etikett vornehmen
if (distVal1 != distVal2) {
	allFrames[0].label = "Abstand aussen: " + distVal1 + " mm\rAbstand innen: " + distVal2 + " mm\rAnzahl Halbkreise: " + numVal + "\rInnen " + delVal + " Viertelkreise entfernt\rRichtung: " + dirTxt;
}
else {
	allFrames[0].label = "Konturen-Abstnde: " + distVal + " mm\rInnen " + delVal + " Viertelkreise entfernt\rRichtung: " + dirTxt;
}

// die Funktion zum Zurcksetzen der Einstellungen aufrufen
reStoreSettings();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiraleVariabel401.txt");
	}
	else {
		var f = new File("~/Library/Preferences/SpiraleVariabel401.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 136;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"SpiraleVariabel"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Strke:", minWidth:labelWidth-10});
						var weightField = realEditboxes.add({editValue:strW, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"pt", minWidth:12});
						staticTexts.add({staticLabel:" ", minWidth:14});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Tonwert:", minWidth:labelWidth-10});
						var tintField = realEditboxes.add({editValue:strT, minimumValue:1, maximumValue:100, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Max. Abstnde der Konturen:"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Aussen:", minWidth:labelWidth-10});
						var distOuterField = realEditboxes.add({editValue:dtV1, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:3});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Innen:", minWidth:labelWidth-10});
						var distInnerField = realEditboxes.add({editValue:dtV2, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:3});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Anzahl Halbkreise:", minWidth:labelWidth-10});
						var numField = integerEditboxes.add({editValue:numV, minimumValue:0, maximumValue:9999, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"", minWidth:33});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Innen"});
				var delField = integerEditboxes.add({editValue:delV, minimumValue:0, maximumValue:9999, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"Viertelkreise entfernen"});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Laufrichtung:", minWidth:50});
						staticTexts.add({staticLabel:" ", minWidth:116});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:8});
						with(dirButtons = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"im Uhrzeigersinn", checkedState:ck01});
							radiobuttonControls.add({staticLabel:"gegen den Uhrzeigersinn", checkedState:ck02});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		// die Eingaben auswerten
		var strWght  = weightField.editValue;
		var strTint  = tintField.editValue;
		var distVal1 = distOuterField.editValue;
		var distVal2 = distInnerField.editValue;
		var numVal   = numField.editValue;
		var delVal   = delField.editValue;
		var dirDec   = dirButtons.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		if (distVal1 == 0 && distVal2 == 0) {
			alert ("Beide Abstandswerte sind Null.\nBitte nochmals.", "Stop");
			reStoreSettings();
			exit();
		}
		else {
			if (distVal2 == 0) {
				distVal2 = distVal1;
			}
			else if (distVal1 == 0) {
				distVal1 = distVal2;
			}
		}
		// die neue Vorgabenliste
		var prefsList = new Array (strWght, strTint, distVal1, distVal2, numVal, delVal, dirDec);
		// in eine Textkette verwandeln
		var prefString = prefsList.join("\n");
		// zur Funktion schicken, welche das Ergebnis in eine Datei schreibt
		writeResult(prefString);
		// den Viertelkreise-entfernen-Wert prfen
		if (distVal1 != distVal2) {
			var maxVal = (numVal*2)-1;
			if (maxVal < delVal) {
				alert ("Maximal " + maxVal + " Viertelkreise sind zu entfernen.\n" + delVal + " ist ein zu grosser Wert.", "Stop");
				reStoreSettings();
				exit();
			}
		}
		// das Ergebnis zum Aufruf zurckschicken
		return [strWght, strTint, distVal1, distVal2, numVal, delVal, dirDec];
	}
	else{
		// wenn "Abbrechen", den Dialog entfernen ...
		aDialog.destroy();
		// ... die Funktion aufrufen, welche die Einstellungen zurcksetzt ...
		reStoreSettings();
		// ... und die Ausfhrung abbrechen
		exit();
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiraleVariabel401.txt");
	}
	else {
		var f = File("~/Library/Preferences/SpiraleVariabel401.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// eventuell genderte Einstellungen zurcksetzen /////////////////////////////////////////////////
function reStoreSettings() {
	// Masseinheiten, Linealursprung und Nullpunkt zurcksetzen
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
	curDoc.viewPreferences.rulerOrigin = rO;
	curDoc.zeroPoint = zP;
	curDoc.layoutWindows[0].transformReferencePoint = tR;
}